%define oname ppxlib

Name:           ocaml-%{oname}
Version:        0.28.0
Release:        %mkrel 2
Summary:        Base library and tools for ppx rewriters
License:        MIT
Group:          Development/OCaml
URL:            https://github.com/ocaml-ppx/ppxlib/
Source0:        %{url}/archive/%{version}/ppxlib-%{version}.tar.gz
# Fedora does not have, and does not need, stdlib-shims
Patch0:         %{name}-stdlib-shims.patch

BuildRequires:  ocaml >= 4.04.1
BuildRequires:  ocaml-base-devel
BuildRequires:  ocaml-cinaps-devel >= 0.12.1
BuildRequires:  ocaml-compiler-libs-janestreet-devel >= 0.11.0
BuildRequires:  ocaml-dune >= 2.7
BuildRequires:  ocaml-findlib
BuildRequires:  ocaml-ppx-derivers-devel >= 1.0
BuildRequires:  ocaml-re-devel >= 1.9.0
BuildRequires:  ocaml-sexplib0-devel >= 0.12
BuildRequires:  ocaml-stdio-devel

# This can be removed when F40 reaches EOL
Obsoletes:      %{name}-doc < 0.27.0-2

%description
The ppxlib project provides the basis for the ppx system, which is
currently the officially supported method for meta-programming in Ocaml.
It offers a principled way to generate code at compile time in OCaml
projects.  It features:
- an OCaml AST / parser/ pretty-printer snapshot, to create a full
  frontend independent of the version of OCaml;
- a library for ppx rewriters in general, and type-driven code generators
  in particular;
- a full-featured driver for OCaml AST transformers;
- a quotation mechanism for writing values representing OCaml AST in the
  OCaml syntax;
- a generator of open recursion classes from type definitions.

%package        devel
Summary:        Development files for %{name}
Group:          Development/OCaml
Requires:       %{name}%{?_isa} = %{version}-%{release}
Requires:       ocaml-compiler-libs-janestreet-devel%{?_isa}
Requires:       ocaml-ppx-derivers-devel%{?_isa}
Requires:       ocaml-sexplib0-devel%{?_isa}

%description    devel
The %{name}-devel package contains libraries and
signature files for developing applications that use
%{name}.

%prep
%autosetup -n ppxlib-%{version} -p1

%build
%dune_build

%install
%dune_install

%check
%dune_check

%files -f .ofiles
%doc CHANGES.md HISTORY.md README.md
%license LICENSE.md

%files devel -f .ofiles-devel


%changelog
* Sat Dec 10 2022 pterjan <pterjan> 0.28.0-2.mga9
+ Revision: 1920375
- Drop incorrect epoch in dependency

* Fri Dec 09 2022 pterjan <pterjan> 0.28.0-1.mga9
+ Revision: 1920117
- Update to 0.28.0 and sync with Fedora

* Sat Oct 08 2022 pterjan <pterjan> 0.27.0-2.mga9
+ Revision: 1895424
- Rebuild for new ocaml-sexplib0

* Sat Oct 08 2022 pterjan <pterjan> 0.27.0-1.mga9
+ Revision: 1895385
- Update to 0.27.0

* Thu May 19 2022 pterjan <pterjan> 0.26.0-2.mga9
+ Revision: 1859283
- Rebuild for OCaml 4.14

* Mon May 09 2022 pterjan <pterjan> 0.26.0-1.mga9
+ Revision: 1857169
- Update to 0.26.0

* Tue Apr 05 2022 umeabot <umeabot> 0.23.0-3.mga9
+ Revision: 1844223
- Mageia 9 Mass Rebuild

* Wed Oct 13 2021 tv <tv> 0.23.0-2.mga9
+ Revision: 1751064
- Upstream fix for OCaml 4.13
- 0.23.0 + Rebuild for ocaml 4.13.1
- Improvedf description

* Fri Mar 19 2021 tv <tv> 0.22.0-7.mga9
+ Revision: 1704842
- Rebuild dor ocaml-migrate-parsetree
- rebuild for new ocaml-migrate-parsetree

* Sat Mar 06 2021 tv <tv> 0.22.0-4.mga9
+ Revision: 1699955
- rebuild for new ocaml-ppx_derivers

* Fri Mar 05 2021 tv <tv> 0.22.0-2.mga9
+ Revision: 1699773
- fix devel subpkg requires

* Fri Mar 05 2021 tv <tv> 0.22.0-1.mga9
+ Revision: 1698870
- 0.22.0

* Sun Jan 10 2021 pterjan <pterjan> 0.12.0-5.mga8
+ Revision: 1670768
- Rebuild to generate ocamlx provides

* Fri Feb 28 2020 umeabot <umeabot> 0.12.0-4.mga8
+ Revision: 1551746
- Rebuild for ocaml 4.10.0 final

* Thu Feb 20 2020 umeabot <umeabot> 0.12.0-3.mga8
+ Revision: 1545837
- Mageia 8 Mass Rebuild

* Thu Jan 30 2020 tv <tv> 0.12.0-2.mga8
+ Revision: 1485314
- rebuild for new ocaml-stdio)

* Mon Jan 27 2020 tv <tv> 0.12.0-1.mga8
+ Revision: 1483803
- new release + rebuild for ocaml-4.10
- fix URL

* Fri Oct 26 2018 pterjan <pterjan> 0.3.1-5.mga7
+ Revision: 1325548
- Also obsolete -devel packages

* Fri Oct 26 2018 pterjan <pterjan> 0.3.1-4.mga7
+ Revision: 1325547
- Obsolete one more package

* Thu Oct 25 2018 pterjan <pterjan> 0.3.1-3.mga7
+ Revision: 1325517
- Obsolete a bunch of ocaml-ppx* it replaces

* Tue Oct 23 2018 pterjan <pterjan> 0.3.1-2.mga7
+ Revision: 1324586
- Rebuild for ocaml-migrate-parsetree 1.1.0

* Tue Oct 23 2018 pterjan <pterjan> 0.3.1-1.mga7
+ Revision: 1324519
- Fix BuildRequires
- Fix file list
- Fix BuildRequires
- imported package ocaml-ppxlib

